/*#######################################################################################
Connect ARM to MMC/SD 

Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include <lpc2119.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "mmc.h"
#include "fat.h"
#include "uart.h"
#include "printf_P.h"

void SystemInit(void)
{

	// --- enable and connect the PLL (Phase Locked Loop) ---
	// a. set multiplier and divider
	SCB_PLLCFG = MSEL | (1<<PSEL1) | (0<<PSEL0);
	// b. enable PLL
	SCB_PLLCON = (1<<PLLE);
	// c. feed sequence
	SCB_PLLFEED = PLL_FEED1;
	SCB_PLLFEED = PLL_FEED2;
	// d. wait for PLL lock (PLOCK bit is set if locked)
	while (!(SCB_PLLSTAT & (1<<PLOCK)));
	// e. connect (and enable) PLL
	SCB_PLLCON = (1<<PLLE) | (1<<PLLC);
	// f. feed sequence
	SCB_PLLFEED = PLL_FEED1;
	SCB_PLLFEED = PLL_FEED2;
	
	// --- setup and enable the MAM (Memory Accelerator Module) ---
	// a. start change by turning of the MAM (redundant)
	MAM_MAMCR = 0;	
	// b. set MAM-Fetch cycle to 3 cclk as recommended for >40MHz
	MAM_MAMTIM = MAM_FETCH;
	// c. enable MAM 
	MAM_MAMCR = MAM_MODE;
	
	// --- set VPB speed ---
	SCB_VPBDIV = VPBDIV_VAL;
	
	// --- map INT-vector ---
	#if defined(RAM_RUN)
	  SCB_MEMMAP = MEMMAP_USER_RAM_MODE;
	#elif defined(ROM_RUN)
	  SCB_MEMMAP = MEMMAP_USER_FLASH_MODE;
	#else
	#error RUN_MODE not defined!
	#endif
}

/* *** MAIN ************************************************************* */
 
int main(void)
{  
	unsigned char buffer[513];
	unsigned short int tmp = 0;
	unsigned short int cluster;
	unsigned char Dir_Attrib = 0;
	unsigned long Size = 0;


	SystemInit();
 
	uart0Init(B9600, UART_8N1, UART_FIFO_8); // setup the UART
	printf("\n\r*** START ***\n\r");
  
	while (mmc_init() != 0) 	//ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
								//MMC/SD-Karte wird dann neu Initialisiert
			{
			   printf("** Keine MMC/SD-Karte gefunden! **\n\r"); 
			}
	
	printf("MMC/SD-Karte gefunden!\n\r"); 
		  
	//Speichern der Cluster Size und Cluster Offset (Anfang Datenbereich)
	Cluster_Data_Store();
	//Initialisierung der MMC/SD-Karte ENDE!


	//Ausgabe des Root Directory <-------------------------------------------------------------
	printf("\nDirectory\n\n\r");
	for (char a = 0;a < 240;a++)
	{
		cluster = Read_Dir_Ent(0,a,&Size,&Dir_Attrib,buffer);
			if (cluster == 0xffff)
			{
				break;
			}
		tmp = (Size & 0x0000FFFF);
		printf("Cluster = %4x DirA = %2x Size= %8d FileName = ",cluster,Dir_Attrib,tmp);
		printf(buffer);
		printf("\n\r");
	}
	printf("\nDirectory Ende\n\n\r");
	
	cluster= 0x0;
	
	/*
	//berschreibt Inhalt von mmc.txt mit "1" <------------------------------------------------
	if (fat_search_file("MMC.TXT",&cluster,&File_Size,&Dir_Attrib,buffer) == 1)
		{
		printf("Loading \n\r");
		}
	else
		{
		printf("File not found!\n\r");
		while(1)
			{
			//ENDE!! File nicht gefunden!!
			} 
		}
		
	printf("\n\rStart write!!\n\r");
	while(File_Size>0)
	{
		for (a=0;a<512;a++)
		{
			buffer[a]= '1';
		}	
		fat_write_file (cluster,&buffer[0],block_counter);
		block_counter++;
		for (a=0;a<512;a++)
			{
			File_Size = File_Size - 1;
			if(File_Size<=0)
				{
				break;
				}
			}
	}

	printf("\n\rStop write!!\n\r");
	
	//Laden eines Files und ausgabe auf der Seriellen Schnitstelle <-------------------
	block_counter = 0x0;
	cluster= 0x0;
	
	if (fat_search_file("MMC.TXT",&cluster,&File_Size,&Dir_Attrib,buffer) == 1)
		{
		printf("Loading \n\r");
		}
	else
		{
		printf("File not found!\n\r");
		while(1)
			{
			//ENDE!! File nicht gefunden!!
			} 
		}

	while(File_Size>0)
	{
		fat_read_file (cluster,buffer,block_counter);
		block_counter++;
		for (a=0;a<512;a=a+1)
			{
			printf("%c",buffer[a]);
			
			File_Size = File_Size - 1;
			if(File_Size<=0)
				{
				break;
				}
			}
	}
	*/
	
	while(1)
		{
		} 
return(0);
}


